import java.util.*;

public class Main {
    public static int count = 0;

    public static void main(String[] args) {
        //printNumsThreeDigits();
        System.out.println("How many digits to search?");
        int k = new Scanner(System.in).nextInt();
        if (k <= 0) {
            System.out.println("number of digits must be positive");
        } else {
            printNumsKDigits(k);
            System.out.println("Total # of combinations: " + count);
        }
    }

    // Prints out all 3-digit combinations of
    // 1, 2, and 3
    public static void printNumsThreeDigits() {
        printNumsThreeDigits("");
    }

    private static void printNumsThreeDigits(String soFar) {
        if (soFar.length() == 3) {
            count++;
            System.out.println(soFar);
        } else {
            printNumsThreeDigits(soFar+ "1");
            printNumsThreeDigits(soFar+ "2");
            printNumsThreeDigits(soFar+ "3");
        }
    }

    // Prints out all k-digit combinations of
    // 1, 2, and 3
    public static void printNumsKDigits(int k) {
        printNumsKDigits(k, "");
    }

    private static void printNumsKDigits(int k, String soFar) {
        if (soFar.length() == k) {
            count++;
            System.out.println(soFar);
        } else {
            printNumsKDigits(k, soFar+ "1");
            printNumsKDigits(k, soFar+ "2");
            printNumsKDigits(k, soFar+ "3");
        }
    }
}